#!/usr/bin/php

<?
  require_once("include.inc.php");
  set_time_limit(0);
  $db_con = connect_db();
  $sql_arr = "";
  $random_mac = "";

  while(feof(STDIN) == false)
  {
    $in = fread(STDIN, 32767);
    $in = trim($in, "\r\n");
    $in = explode("\n", $in);

    $count_in = count($in);

echo " " . $count_in . " string(s) from tcpdump\n";

    for($i = 0; $i < $count_in; $i++)
    {
      $str =  trim($in[$i], "\r\n");

      if( strlen($str) != 0)
      {
        $j = 0;

        $strs = split(" ", $str);

        list($timestamp, $msec) = split('\.', $strs[0]);

//timestamp
        $sql_arr[$j] = $timestamp;
        $j++;
//end

//msec
        $sql_arr[$j] = $msec;
        $j++;
//end

//mac
        $sql_arr[$j] = shortmac($strs[1]);
        if($sql_arr[$j] == "FFFFFFFFFFFF")
          $sql_arr[$j] = "";
        $j++;
//end

//mac
        $sql_arr[$j] = shortmac(trim($strs[3], ","));
        if($sql_arr[$j] == "FFFFFFFFFFFF")
          $sql_arr[$j] = "";
        $j++;
//end

//len
        $sql_arr[$j] = trim($strs[8], ":");
        $j++;
//end

//ip
        $sql_arr[$j] = vsprintf("%u", ip2long($strs[11]));
        $j++;
//end

//type & ip
        $sql_arr[$j] = 0;
        if( ($strs[10] == "who-has") &&
            ($strs[12] == "tell") )
        {
          $sql_arr[$j]     = 1;
          $sql_arr[$j + 1] = vsprintf("%u", ip2long($strs[13]));
        }

        if( ($strs[10] == "who-has") &&
            ($strs[12] == "(ff:ff:ff:ff:ff:ff)") )
        {
          $sql_arr[$j]     = 2;
          $sql_arr[$j + 1] = vsprintf("%u", ip2long($strs[14]));
        }

        if($strs[10] == "reply")
        {
          $sql_arr[$j]     = 3;
          $sql_arr[$j + 1] = $sql_arr[5];
          $sql_arr[5]      = 0;
        }
//end

/*
        echo "\n";
        for($k = 0; $k < count($sql_arr); $k++)
          echo $k . " = " . $sql_arr[$k] . "\n";

        echo " --------------- \n";
        echo $in[$i] . "\n";
        echo " --------------- \n\n";
/**/

        $arp_do = $cfg["main"]["arp_do"];

	$src_ip  = $sql_arr[7];
	$src_mac = $sql_arr[2];
	$dst_ip  = $sql_arr[5];
	$type_id = $sql_arr[6];

/*
echo "src_mac = " . $src_mac . "\n";
echo "rnd_mac = " . $random_mac . "\n";
/**/

	$todo_id = 1;
	
	if($src_mac == $random_mac)
	{
	  $arp_do = 0;
	  $todo_id = 4;
	} else
	{
  	  $arp_doit = 1;
	}

	if($arp_do >= 1)
	{
          $SQL = "SELECT ip, change_ip FROM comp WHERE mac=? AND status=1";
          $sql_res = $db_con->GetAll($SQL, array($src_mac));
          check_sql_result($sql_res, $SQL, 1);

	  $count_sql_res = count($sql_res);

	  if($count_sql_res >= 1)
	  {
	    if($sql_res[0]["change_ip"] == 1) //  ip
	    {
	      $arp_doit = 0;
	    } else
	    {
	      if($sql_res[0]["ip"] == $src_ip)
	        $arp_doit = 0; else
	        $arp_doit = 1;
	    }
	  } else
	  {
	    $todo_id = 2;
	  }

	  if($arp_doit == 1)
	  {
	    if($arp_do == 1)
	      $arp_doit = 0;

	    if( ($arp_do == 2) && ($src_ip != $dst_ip) )
              $arp_doit = 0;

	    if($arp_do == 3)
	      $arp_doit = 1;
	  }

	  if(($arp_doit == 1) && ($type_id != 3))
	  {
	    $exec = $cfg["main"]["arp_exec"];
	    $exec = str_replace("<ip>", long2ip($src_ip), $exec);
	    $exec = str_replace("<mac>", shortmac2long($src_mac), $exec);
	    $random_mac = str_max(rand()%999999999999, 12, "0");
	    $exec = str_replace("<random_mac>", shortmac2long($random_mac) , $exec);
	    execute($exec);
	    echo "  end arp...\n";
	    
	    $todo_id = 3;
	  }
	}

        $sql_arr[$j + 2] = $todo_id;
        $SQL = "INSERT INTO log (timestamp, msec, src_mac, dst_mac, len, dst_ip, type_id, src_ip, todo_id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)";
        $sql_res = $db_con->Execute($SQL, $sql_arr);
        check_sql_result($sql_res, $SQL, 1);
      }
    }
  }
?>
