<?
  function connect_db()
  {
    $dsn  = $GLOBALS['cfg']['db']['name'] . "://";
    $dsn .= $GLOBALS['cfg']['db']['user'] . ":";
    $dsn .= $GLOBALS['cfg']['db']['pass'] . "@";
    $dsn .= $GLOBALS['cfg']['db']['host'];
    if(strlen($GLOBALS['cfg']['db']['port']) != 0)
      $dsn .= ":" . $GLOBALS['cfg']['db']['port'];
    $dsn .= "/" . $GLOBALS['cfg']['db']['db'];
    if($GLOBALS['cfg']['db']['persist'] == true)
      $dsn .= "?persist";

    $db = NewADOConnection($dsn);
    if(!$db)
    {
      $mess = "Error connection to " . $GLOBALS['cfg']['db']['name'] . "... exit...";
      write_log($mess);
      die ($mess . "\n");
    }
    $db->debug = $GLOBALS['cfg']['db']['debug'];

    return $db;
  }

  function check_file($f, $file_name, $mess, $write_to_log, $die)
  {
    if($f == false)
    {
      $ret = 0;
      if($write_to_log == 1)
      {
        $mess .= " failed: " . $file_name . "...";
        if($die == 1)
        {
          $mess .= "\nExit...";
          echo $mess . "\n";
          write_log($mess);
          die;
        } else
        {
          write_log($mess);
        }
      }
    } else
    {
      $ret = 1;
    }

    return $ret;
  }

  function write_log($str)
  {
/*
    $cur_date = date("Y-m-d H:i:s");
    $filename = $GLOBALS['cfg']['db']['sql_err'];
    $f = fopen($filename, "a");
    check_file($f, $filename, "fopen (a)", 0, 1);

    $res = fwrite($f, $cur_date . "\n" . $str . "\n\n");
    check_file($res, $filename, "write", 0, 1);
*/
  }

  function check_sql_result($res, $sql, $die)
  {
    if($res === false)
    {
      $ret = 0;
      echo "sql error";

      if($die == 1)
      {
        echo " - die...\n";
        write_log($sql . "\ndie...");
        die;
      } else
      {
        echo " - continue...\n";
        write_log($sql);
      }
    } else
    {
      $ret = 1;
    }

    $GLOBALS['var']['sql_count']++;

    return $ret;
  }

  function getmicrotime()
  {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
  }

  function shortmac($mac)
  {
    $ret = $mac;
    $ret = str_replace(':', "", $ret);
    $ret = str_replace('-', "", $ret);

    return strtoupper($ret);
  }
  
  function shortmac2long($mac, $char = ":")
  {
    $ret = "";

    $strlen_mac = strlen($mac);    
    for($i = 0; $i < $strlen_mac; $i++)
    {
      $ret .= $mac[$i];
      if($i != $strlen_mac - 1)
        if( ($i+1) / 2 == (int)(($i+1) / 2) )
          $ret .= $char;
    }
    
    return $ret;
  }
  
  function execute($exec)
  {
    echo "  running:\n";
    echo $exec . "\n";
    $ret = system($exec);
    
    return $ret;
  }
  
  function str_max($str, $max, $char)
  {
    $ret = "";

    $strlen_str = strlen($str);
    for($i = 0; $i < $max - $strlen_str; $i++)
       $ret .= $char;

    $ret .= $str;
    
    return $ret;
  }

  function style()
  {
?>
<style type="text/css">
<!--
body {background-color: #FFFFFF; color: #000000;}
table {border-collapse: collapse;}
hr {background-color: #AABBCC; border: 0px; height: 1px; color: #000000;}
//-->
</style>
<?
  }
  
  function br()
  {
    echo "<br>\n";
  }

  function hr()
  {
    echo "<hr>\n";
  }

  function start_ses()
  {
    session_name($GLOBALS['cfg']['ses']['ses_name']);
    session_cache_limiter($GLOBALS['cfg']['ses']['ses_cache_limiter']);
    session_cache_expire($GLOBALS['cfg']['ses']['ses_cache_expire']);

    ini_set("session.bug_compat_warn", $GLOBALS['cfg']['ses']['ses_bug_compat_warn']);
    ini_set("session.cookie_lifetime", $GLOBALS['cfg']['ses']['cookie_lifetime']);
    ini_set("session.use_only_cookies", $GLOBALS['cfg']['ses']['ses_use_only_cookies']);
    ini_set("session.use_cookies", $GLOBALS['cfg']['ses']['ses_use_cookies']);

    session_start();
  }

  function check_ses()
  {
    start_ses();
    if( isset($_SESSION["SES_user_ok"]) )
      $ret = 1; else
      $ret = 0;

    if($ret == 0)
    {
      redirect("index.php", " ");
    }

    return $ret;
  }

  function GET($par_name, $def_value, $addslashes = 1)
  {
    if( isset($_GET[$par_name]) )
    {
      if($addslashes == 1)
        $ret = addslashes($_GET[$par_name]); else
        $ret = $_GET[$par_name];
    } else
    {
      $ret = $def_value;
    }

    return $ret;
  }

  function POST($par_name, $def_value, $addslashes = 1)
  {
    if( isset($_POST[$par_name]) )
    {
      if($addslashes == 1)
        $ret = addslashes($_GET[$par_name]); else
        $ret = $_GET[$par_name];
    } else
    {
      $ret = $def_value;
    }

    return $ret;
  }

  function php_start()
  {
    $GLOBALS['var']['php_start'] = getmicrotime();
  }

  function php_finish()
  {
    $GLOBALS['var']['php_finish'] = getmicrotime();
  }

  function show_php_stat()
  {
    echo "<hr>\n";

    echo "<table border=0 width=100% cellspacing=0>\n";

    echo "<tr>\n";
    echo "<th align=left bgcolor=EEF0FF><small>\n";
    echo "  : <b>" . number_format($GLOBALS['var']['php_finish'] - $GLOBALS['var']['php_start'], 3) . "</b> .\n";
    echo "<big></th>\n";

    echo "<th align=right bgcolor=EEF0FF><small>\n";
    echo " : <b>" . number_format($GLOBALS['var']['sql_count']) . "</b>\n";
    echo "<big></th>\n";
    echo "</tr>\n";
  }

  function redirect($url, $title)
  {
    header("Location: redirect.php?url=" . $url . "&title=" . $title);
    die;
  }
  
  function redirect_link($url, $title_link, $title)
  {
    echo "<a href=redirect.php?url=" . $url . "&title=" . urlencode($title) . ">" . $title_link . "</a>\n";
  }

  function show_top_menu()
  {
?>
<table border=0 width=100% cellspacing=0>
  <tr bgcolor=EEF0FF>
    <td align=right colspan="2">
<?
  redirect_link("index.php", "", " ");
?>
    </td>
  </tr>
  
  <tr bgcolor=EEF8FF>
    <td align=center>
<a href=computers.php></a>
    </td>

    <td align=center>
<a href=arp_dog_log.php>ARP_dog log</a>
    </td>
  </tr>
</table>
<hr>
<?
  }

  function show_calend($year, $month, $day, $varname, $addurl)
  {
    $day_w = date("w", mktime(0, 0, 0, $month, 1, $year));
    if($day_w == 0) $day_w = 7;
    $day_n = date("t", mktime(0, 0, 0, $month, $day, $year));
    echo "<table CLASS=table CELLSPACING=0 CELLPADDING=3 bordercolor=black border=1>\n";
    echo "<td colspan=7 align=center bgcolor=AABBCC><font color=3F4170 size=4><b>".$day." ";
    if ($month ==  1) echo "";
    if ($month ==  2) echo "";
    if ($month ==  3) echo "";
    if ($month ==  4) echo "";
    if ($month ==  5) echo "";
    if ($month ==  6) echo "";
    if ($month ==  7) echo "";
    if ($month ==  8) echo "";
    if ($month ==  9) echo "";
    if ($month == 10) echo "";
    if ($month == 11) echo "";
    if ($month == 12) echo "";
    echo " " . $year . "</b></font></td>\n";
    echo "<tr CLASS=menu>\n";
    $days[0]="";
    $days[1]="";
    $days[2]="";
    $days[3]="";
    $days[4]="";
    $days[5]="";
    $days[6]="";
    for($i = 0; $i < 7; $i++)
      echo "<td align=center><font color=2B8F8F size=3><b>$days[$i]</b></font></td>";
    echo "</tr>";
    for($i = 1; $i <= ((int)(($day_n+$day_w-2)/7)+1)*7; $i++)
    {
      if (($i - 1) % 7==0)
        echo "</tr>\n<tr align=center CLASS=table>";

      $cal_day = $i - $day_w + 1;

      if( ($i >= $day_w) && ($cal_day <= $day_n) )
      {
        if($month <= 9)
          $month = "0" . (int)$month;

        if($cal_day <= 9)
          $cal_day = "0" . (int)$cal_day;

        $url = "?" . $addurl . "&" . $varname . "=" . $year . "-" . $month . "-" . $cal_day;
        echo "<td><a href=\"$url\">";
        if($cal_day == $day)
          echo "<font color=green><big>[" . (int)$cal_day . "]<small></font></td>";else
        if(($i % 7) &&
           (($i + 1) % 7))
          echo (int)$cal_day . "</td>";else
          echo "<font color=red>" . (int)$cal_day . "</font></td>";
        echo "</a></td>";
      }else
      {
        echo "<td>&nbsp;</td>";
      }
      echo "\n";
    }
    $month_prev = $month - 1;
    $year_prev = $year;
    $month_next = $month + 1;
    $year_next = $year;
    if($month <= 1)
    {
      $month_prev = 12;
      $year_prev = $year - 1;
    }else
    if($month >= 12)
    {
      $month_next = 1;
      $year_next = $year + 1;
    }

    if($month_prev <= 9)
      $month_prev = "0" . (int)$month_prev;

    if($month_next <= 9)
      $month_next = "0" . (int)$month_next;

    echo "\n";
    echo "<tr align=center bgcolor=AABBCC>";
    echo "<td><a href=?" . $addurl . "&" . $varname . "=" . ($year-1) . "-" . $month . "-" . $day . ">&lt;&lt;</a></td>";
    echo "<td>&nbsp;</td>";
    echo "<td><a href=?" . $addurl . "&" . $varname . "=" . $year_prev . "-" . $month_prev . "-" . $day . ">&lt;</a></td>";
    echo "<td>&nbsp;</td>";
    echo "<td><a href=?" . $addurl . "&" . $varname . "=" . $year_next . "-" . $month_next . "-" . $day . ">&gt;</a></td>";
    echo "<td>&nbsp;</td>";
    echo "<td><a href=?" . $addurl . "&" . $varname . "=" . ($year+1) . "-" . $month . "-" . $day . ">&gt;&gt;</a></td>";
    echo "</tr>";
    echo "</table>";
  }

  function cur_datetime($datetime = 0)
  {
    $ret = "";
    
    if($datetime == 0)
      $ret = date("Y-m-d H:i:s");

    if($datetime == 1)
      $ret = date("Y-m-d");

    if($datetime == 2)
      $ret = date("H:i:s");

    return $ret;
  }

  function split_date(&$year, &$month, &$day, $date)
  {
    list($year, $month, $day) = split("-", $date);
  }















/*
  function add_rewrite_q_str($q_str, $par_name, $old_value, $new_value)
  {
    $ret = str_replace("&" . $par_name . "=" . $old_value, "", $q_str);
    if($ret == $q_str)
    {
      $ret = str_replace($par_name . "=" . $old_value . "&", "", $q_str);
      if($ret == $q_str)
      {
        $ret = str_replace($par_name . "=" . $old_value, "", $q_str);
        if(strlen($ret) == 0)
          $ret .= $par_name . "=" . $new_value; else
          $ret .= "&" . $par_name . "=" . $new_value;
      } else
      {
        $ret .= "&" . $par_name . "=" . $new_value;
      }
    } else
    {
      $ret .= "&" . $par_name . "=" . $new_value;
    }

    return $ret;
  }

  function remove_q_str($q_str, $par_name, $old_value)
  {
    $ret = str_replace("&" . $par_name . "=" . $old_value, "", $q_str);
    if($ret == $q_str)
    {
      $ret = str_replace($par_name . "=" . $old_value . "&", "", $q_str);
      if($ret == $q_str)
        $ret = str_replace($par_name . "=" . $old_value, "", $q_str);
    }

    return $ret;
  }

  function tarif_period_text_mb($db_con, $mb, $tarif_id)
  {
    // 
    $SQL = "SELECT period_id, coef FROM tarif_period WHERE tarif_id=\"" . $tarif_id . "\" ORDER BY period_id";
    $sql_res_tarif_period = $db_con->GetAll($SQL);
    check_sql_result($sql_res_tarif_period, $SQL, 1);
    //end

    $ret = "";
    $count = count($sql_res_tarif_period);
    for($i = 0; $i < $count; $i++)
    {
      $ret .= number_format($mb * $sql_res_tarif_period[$i][1], 3);
      if($i != $count - 1)
        $ret .= " / ";
    }

    return $ret;
  }


  function style()
  {
?>
<style type="text/css">
<!--
body {background-color: #FFFFFF; color: #000000;}
table {border-collapse: collapse;}
td {padding: 2pt; border: 1px solid #000000;}
th {padding: 2pt; border: 0px solid #000000; font: 16px "Times New Roman", sans-serif, Verdana, Helvetica;}
hr {background-color: #AABBCC; border: 0px; height: 1px; color: #000000;}
//-->
</style>
<?
  }

  function html_status($val, $var)
  {
    $v[0][0] = " ";
    $v[0][1] = "";
    $v[0][2] = "";

    $v[1][0] = " ";
    $v[1][1] = "";
    $v[1][2] = "";

    $v[2][0] = " ";
    $v[2][1] = "";
    $v[2][2] = "?";

    if($val == 0)
      $html_res = "<font color=red>" . $v[$var][0] . "</font>";
    if($val == 1)
      $html_res = "<font color=green>" . $v[$var][1] . "</font>";
    if($val == 2)
      $html_res = "<font color=red>" . $v[$var][2] . "</font>";

    return $html_res;
  }


  function get_user_group($db_con, $user_id)
  {
    $SQL = "SELECT aaa.user_name, bbb.group_name FROM users aaa, groups bbb WHERE aaa.id=\"" . $user_id . "\" AND aaa.group_id=bbb.id";
    $sql_res_user = $db_con->GetAll($SQL);
    check_sql_result($sql_res_user, $SQL, 1);

    if( count($sql_res_user) != 1 )
      $user_group = "unknown@unknown"; else
      $user_group = $sql_res_user[0][0] . "@" . $sql_res_user[0][1];

    return $user_group;
  }

  function show_user_text($user_group, $date1, $date2, $host)
  {
?>
<big><big> <br>
<?
  echo "<font color=red>" . $user_group . "</font>\n";
?>
<br>
c <font color=blue>
<?  echo $date1;  ?>
</font>
 <font color=blue>
<?  echo $date2;  ?>
</font>
<?
    if(strlen($host) != 0)
    {
      echo "<br>\n <br>\n<font color=green>" . $host . "</font>\n";
    }
?>
<small><small>
<?
  }

  function print_date($day1, $month1, $year1, $day2, $month2, $year2)
  {
    echo " <b><font color=AA33AA>".sprintf("%02d", $day1).".".sprintf("%02d", $month1).".".$year1."</font></b>";
    echo "  <b><font color=AA33AA>".sprintf("%02d", $day2).".".sprintf("%02d", $month2).".".$year2."</font></b>";
  }


  function admin_log($db_con, $user_id, $group_id, $user_group, $ip, $mess)
  {
    $SQL = "INSERT INTO admin_log (user_id, group_id, user_group, ip, log) VALUES (\"" . $user_id . "\", \"" . $group_id . "\", \"" . $user_group . "\", \"" . $ip . "\", \"" . addslashes($mess) . "\")";
    $sql_res = $db_con->Execute($SQL);
    check_sql_result($sql_res, $SQL, 1);
  }

  function admin_log_user_id($db_con, $user_id, $mess)
  {
    $ip = $_SERVER["REMOTE_ADDR"];
    // 
    $SQL = "SELECT user_name, group_id FROM users WHERE id=\"" . addslashes($user_id) . "\"";
    $sql_res_user = $db_con->GetAll($SQL);
    check_sql_result($sql_res_user, $SQL, 1);
    //end

    //  
    if( count($sql_res_user) == 0 )
    {
      admin_log($db_con, $user_id, "0", "unknown@unknown", $ip, $mess);
    } else
    {
      // 
      $SQL = "SELECT group_name FROM groups WHERE id=\"" . $sql_res_user[0][1] . "\"";
      $sql_res_group = $db_con->GetAll($SQL);
      check_sql_result($sql_res_group, $SQL, 1);
      //end

      //  
      if( count($sql_res_user) == 0 )
        admin_log($db_con, $user_id, $sql_res_user[0][1], $sql_res_user[0][0] . "@unknown", $ip, $mess); else
        admin_log($db_con, $user_id, $sql_res_user[0][1], $sql_res_user[0][0] . "@" . $sql_res_group[0][0], $ip, $mess);
    }
  }



/*
  admin_level - 2 byte
  bit
  0 -   1 -   
  1 -   2 -    /      / 
  2 -   4 - / 
  3 -   8 -    
  4 -  16 - / 
  5 -  32 - / 
  6 -  64 - / 
  7 - 128 -   
  8 - 256 - /  

876543210 -  
xxxxxxxxx -  
*/

  function text_admin_level($bit)
  {
                   //bit
    $text_admin_level[0] = ".  ";
    $text_admin_level[1] = ". / / ";
    $text_admin_level[2] = "/ ";
    $text_admin_level[3] = ".   ";
    $text_admin_level[4] = "/ ";
    $text_admin_level[5] = "/ ";
    $text_admin_level[6] = "/ ";
    $text_admin_level[7] = ".  ";
    $text_admin_level[8] = "/  ";

    return $text_admin_level[$bit];
  }

  function getbit($val, $offset)
  {
    $val = (int)$val;
    $offset = (int)$offset;

    $bit = 1 << $offset;

    if( ($val & $bit) == $bit)
      $ret = 1; else
      $ret = 0;

    return $ret;
  }

  function admin_level_count()
  {
    return 9;
  }

?>